'0006.BAS:  Externe Interrupts
'Hardware:  MAX232 an PD0/PD1, Nullmodemkabel zum PC
'           PD4 an Taste 2, PD3 (Int1) an Taste 1
'           PD2 (Int0) an RTS-Ausgang vom MAX232
'---------------------------------------------------------
$Regfile = "2313def.dat" 'AT90S2313-Deklarationen
$Crystal = 3686400       'Quarz: 3.6864 MHz
$Baud = 9600             'UART-Baudrate: 9600 Baud

DDRD = &B11101111     'PD4 Eingang, Rest Ausgang
'DDRD = &B11100011    'PD2+3+4 Eingang, Rest Ausgang
'PORTD = &B00011100   'Pullups von PD2+3+4 aktivieren
PORTD.2 = 1           'PullUp von PD2/Int0 aktivieren
PORTD.3 = 1           'PullUp von PD3/Int1 aktivieren
PORTD.4 = 1           'PullUp von Pin PD4 aktivieren

On INT0 OnRts         'Interrupt-Routine fr RTS
On INT1 OnTaste1      'Interrupt-Routine fr Taste 1
Config INT0 = FALLING 'Interrupt 0 bei H/L-Flanke auslsen
Config INT1 = FALLING 'Interrupt 1 bei H/L-Flanke auslsen
Enable INT0           'Externen Interrupt 0 einschalten
Enable INT1           'Externen Intterrupt 1 einschalten
Enable Interrupts     'Interrupts global zulassen
'---------------------------------------------------------
Print Bin(DDRD)
Do                    'Hauptschleife
  If PIND.4 = 0 Then  'Wenn Taste 2 gedrckt
    Print "T2 ";      'Ereignis via UART melden
  End If
Loop
'---------------------------------------------------------
OnRts:                'Int0-Routine
  Print "RTS ";       'Ereignis via UART melden
Return
'---------------------------------------------------------
OnTaste1:             'Int1-Routine
  Print "T1 ";        'Ereignis via UART melden
Return