'0011.BAS:  Halbwegs effizienter Empfang von Strings via UART
'Hardware:  MAX232 an PD0/PD1, Nullmodemkabel zum PC
'Das Wort "effizient" meint hier nur, da die Vorgehensweise wesentlich
'effizienter ist, als der Befehl Input, denn dieser Befehl kehrt erst
'zurck, wenn der String voll ist. - Und die bertragung von 10 Bytes
'dauert bei 9.600 Baud immerhin 1/96 Sekunde (viele viele Takte).
'Die hier verwendete Methode String=String+Zeichen ist auf Assembler-
'Ebene betrachtet natrlich eine recht aufwendige Operation, aber im
'Vergleich zu Input kostet geradezu lcherlich wenig Zeit.
'----------------------------------------------------------------------
$Regfile = "2313def.dat"  'AT90S2313-Deklarationen
$Crystal = 3686400        'Quarz: 3.6864 MHz
$Baud    = 9600           'UART-Baudrate: 9600 Baud

Dim sTest As String*10
Dim nTakte as Word

On URXC OnRxD             'Interrupt-Routine setzen
Enable URXC               'Interrupt URXC einschalten
Enable Interrupts         'Interrupts global zulassen

Config Timer1 = Timer, Prescale = 1

Main:                     'Hauptschleife
  If Len(sTest) > 9 Then  'Sobald der String 10 Zeichen enthlt...
    Print sTest           'String zur Kontrolle via UART zurcksenden
    sTest = ""            'String leeren
  End If
Goto Main
'----------------------------------------------------------------------
OnRxD:                    'EIN Zeichen ist in der UART eingetroffen
  Timer1 = 0
  sTest = sTest + CHR(UDR)  'Zeichen aus der UART an den String anhngen
  nTakte = Timer1
  Print "Stringlnge: ";Len(sTest);", Takte: ";nTakte
Return
