'0012.BAS:  Sehr effizienter Empfang von Strings via UART
'Hardware:  MAX232 an PD0/PD1, Nullmodemkabel zum PC
'Das Programm macht "nach auen hin" exakt dasselbe wie 0010.BAS, ist aber
'effizienter.
'Der Trick liegt hier darin, da wir auf ein und den selben Speicherbereich
'mit zwei vllig verschiedene Methoden zugreifen. Der Speicher fr den String
'wird gleichzeitig durch ein Byte-Feld mit 10 Adressen belegt. So knnen wir
'uns aussuchen, auf welche Weise wir den Inhalt des Strings bearbeiten wollen.
'
'Anmerkung:
'Ein String wird in Bascom immer mit einem Null-Byte abgeschlossen. Ein
'10-Byte-String belegt im SRAM deshalb 11 Bytes. In unserem Beispiel mssen
'wir das Null-Byte aber nicht verndern ("verschieben"), weil wir den String
'sowieso stets dann ausgeben, wenn der String 10 Bytes enthlt. Das Null-Byte
'kann also auf Byte 11 stehenbleiben wie es ist.
'----------------------------------------------------------------------
$Regfile = "2313def.dat"  'AT90S2313-Deklarationen
$Crystal = 3686400        'Quarz: 3.6864 MHz
$Baud    = 9600           'UART-Baudrate: 9600 Baud

Dim sTest As String*10 At &H60         'Adresse &H60: Anfang des SRAM
Dim bTest(11) As Byte At &H60 Overlay  'Selbe Adresse und Lnge wie sTest!
Dim nZeichen As Byte                   'Das ist unser "String-Pointer"
Dim nTakte as Word

On URXC OnRxD             'Interrupt-Routine setzen
Enable URXC               'Interrupt URXC einschalten
Enable Interrupts         'Interrupts global zulassen

Config Timer1 = Timer, Prescale = 1

Main:                     'Hauptschleife
  If nZeichen > 9 Then    'Sobald der String 10 Zeichen enthlt...
    Print sTest           'String zur Kontrolle via UART zurcksenden
    nZeichen = 0          'Stringlnge (bzw. Index) zurcksetzen
  End If
Goto Main
'----------------------------------------------------------------------
OnRxD:                    'EIN Zeichen ist in der UART eingetroffen
  Timer1 = 0
  Incr nZeichen
  bTest(nZeichen) = UDR  'Zeichen aus der UART ins Zeichen-Feld geben
  nTakte = Timer1
  Print "Stringlnge: ";nZeichen;", Takte: ";nTakte
Return
