'0015.BAS: HD4478-kompatible LCD-Anzeige mit 1 oder 2 Zeilen, einfaches Beispiel
'          --->korrigierte Version, beim Original waren die LCD-Pins 4+5 vertauscht.
'              Damit blieb RS permanent auf Masse.
'Hardware: LCD-Anzeige mit HD4478-kompatibler Schnittstelle
'          LCD-Verbindungen:
'          LCD01 an Masse (VSS)
'          LCD02 an +5V   (VDD)
'          LCD03 an Poti2 (V0)
'          LCD04 an PD5   (RS)
'          LCD05 an PD6   (R/W)  --> bleibt permanent auf Masse (0V)
'          LCD06 an PB0   (E)
'          LCD11 an PB1   (DB4)
'          LCD12 an PB2   (DB5)
'          LCD13 an PB3   (DB6)
'          LCD14 an PB4   (DB7)

'Der RW-Eingang der LCD-Anzeige (steuert die Datenrichtung) wird von Bascom
'nicht verwendet und *mu* auf Masse liegen, damit die LCD-Anzeige auf die
'Signale reagiert. Da wir auf dem Experimentierboard keine Masse-Buchse haben,
'mibrauchen wir einfach Pin PD5, den wir auf LOW setzen (der Pin kann narlich
'sinnvoll bei eventuellen Erweiterungen genutzt werden).
'
'Wichtig: Die LPT-Stromversorgung kann fr die LCD nicht verwendet werden, weil
'         der LCD-Controller HD4478 viel Strom zieht (15 bis 30mA).
'         Also bitte externe Stromversorgung nehmen und nicht vergessen, in den
'         WinAVR-Einstellung die LPT-Stromversorgung auszuschalten (sonst setzt
'         WinAVR die Stromversorgungsleitungen nach Ende der Programmierung).
'-------------------------------------------------------------------------------
$Regfile = "2313def.dat"
$Crystal = 3686400  '3,6864MHz-Quarz

DDRD.6  = 1  'Datenrichtung: PD6 soll Ausgang sein (LCD-Anschlu R/W)
PORTD.6 = 0  'Pin PD6 auf LOW setzen (nicht verwendet, MU aber LOW sein)

Config Lcd=16*2 'Wir haben ein LCD-Display mit 16 Zeichen in 2 Zeilen
Config LcdPin=Pin,DB4=PortB.1,DB5=PortB.2,DB6=PortB.3,DB7=PortB.4,E=PortB.0,RS=PortD.5

'Der HD4478 fhrt beim Anlegen der Betriebsspannung einen PowerOn-Reset durch.
'Das dauert >15mSec sobald 4,5 Volt erreicht sind und >40mSec bei 2,7Volt.
'Besonders leistungsstrkere Netzteile fahren ihre Spannung aber beim Ein-
'schalten viel zu langsam hoch (Elko-Ladung). Dann reicht das PowerOn-Reset
'oft nicht. Abhilfe: Entweder eine Verzgerungsschaltung fr die Betriebs-
'spannung der LCD oder zumindest noch ein HD4478-Reset mit derr Instruktion
'InitLcd durchfhren.
InitLcd      'LCD-Reset per Instruktion (HD4478-PowerOn-Reset reicht oft nicht)
Cls          'Anzeige lschen
Cursor Off   'LCD-Kursor ausschalten
Lcd "Hallo"
LowerLine    'In die untere Zeile gehen
Lcd "Welt"

Main:
Goto Main