'0017.BAS:  Analog-Komparator
'Hardware:  Drahtverbindungen:
'           LED(grn)-PB4
'           Poti1 - PB1/AIn1
'           Poti2 - PB0/AIn2
'Funktion:  Die LED beginnt zu leuchten, sobald die Spannung an Poti 2 hher wird als die an
'-------------------------------------------------------------------------------------------
$Regfile="2313def.dat"
$Crystal=3686400  '3,6864MHz-Quarz

On ACI OnComparator 'Interrupt-Routine

DDRB=&B11111100  'Datenrichtung PortB: PB0+PB1=Eingang, Rest Ausgang

'Fr die Konfiguration des Analogen Komparators gibt es dan Bascom-Befehl Config ACI. In
'Bascom Version 1.11.7.0 kann man mit diesem Befehl aber (noch) nicht einstellen, bei welcher
'Flanke (steigend/fallend/nderung) dar Komparator-Interrupt ausgelst werden soll. Als
'Ausweg wird hier deshalb der direkte Weg ber das Komparator-Register ACSR gegangen.
'Config ACI=ON       'Analog-Komparator einschalten
'Enable ACI          'Komparator-Interrupt ein

'ACSR-Register:
'Bit7=ACD:   0-->Komparator an, 1--->Komparator aus
'Bit6=Res:   Reserviert (immer 0)
'Bit5=ACO:   Komparator-Ausgang (nur lesen mglich)
'Bit4=ACI:   1, wenn Interruptanforderung (Lschen: 1 schreiben)
'Bit3=ACIE:  1-->ACI-Interrupt ein, 0--->ACI-Interrupt aus
'Bit2=ACIC:  0-->Keine Verbindung zu Timer1, 1--->AC-Ausgang mit Timer1-Eingang verbunden
'Bit1=ACIS1: \  00: Interrupt bei nderung, 01: Reserviert
'Bit0=ACIS0: /  10: Interrupt an fallender Flanke, 11: Interrupt an steigender Flanke

ACSR=&B0001111      'Komparator konfigurieren VOR DEM EINSCHALTEN DER INTERRUPTS
Enable Interrupts   'Interrupts global ein

Main:               'Hauptschleife
Goto Main
'-------------------------------------------------------------------------------------------
OnComparator:       'Komparator-Interruptroutine
  If ACSR.ACO=1 Then
    PORTB.2=1       'LED an
  Else
    PORTB.2=0       'LED aus
  End If
Return