'0021.BAS:  PowerDown-Modus
'Hardware:  LED an PD5
'           Taster 1 an INT0/PD2
'Funktion:
'In der Hauptschleife wird bei jedem Durchlauf der Zustand der LED gendert.
'Danach wird der AVR in den PowerDown-Zustand versetzt und damit "stillgelegt".
'Erst Ein externer Interrupt0 (Tastendruck) aktiviert den AVR wieder und das
'Programm wird fortgesetzt. Die Interrupt0-Routine wird in unserem Fall zwar
'als erste Aktion nach dem Interrupt ausgefhrt, aber wir tun dort nichts
'weiter, weil es nur um die Demonstration der Reaktion in der Hauptschleife
'geht. Die Reaktion auf den Tastendruck ist brigens jedes mal anders, da so
'lange Interrupts gefeuert werden, wie die Taste gedrckt ist (keine genau
'zu definierende Zeit). Es kann also sein, da man die Taste mehrfach drcken
'mu.
'--------------------------------------
$Regfile="2313def.dat"
$Crystal=3686400      '3,6864MHz-Quarz

On INT0 OnInt0        'Interrupt-Routine fr Interrupt0 festlegen

DDRD=&B11111011       'PD5 Ausgang, PD2/INT0 Eingang, Rest egal
PORTD.2=1             'PullUp von PD2/INT0 aktivieren
Config INT0=LOW LEVEL 'Externe Interrupts bei Low Level feuern (RISING oder FALLING beendet PowerDown nicht!)
Enable INT0           'Externen Interrupt0 einschalten
Enable Interrupts     'Interrupts global

Main:
  PORTD.5=NOT PORTD.5 'LED-Status ndern (von ein nach aus oder von aus nach ein)
  PowerDown           'PowerDown-Ende nur durch Reset, Watchdog Reset oder INTx bei Config INTx=LOW LEVEL
  'Idle               'Idle-Ende auch bei Config INTx=FALLING u.a.m.
Goto Main
'--------------------------------------
OnInt0: 'Wird angesprungen, aber wir tun hier nichts
Return