'ADC01.BAS: A/D-Konverter mit dem Komparator, Datenausgabe via UART
'          Der Mebereich betrgt 0...242 (0...4,8Volt)
'Bentigte Hardware:
' - Nullmodemkabel zum PC fr die Datenausgabe
' - Pin PB0/Ain2: 10 nF nach Masse, 15K nach PD6 (Ladekondensator fr den Spannungsvergleich)
' - Pin PB1/Ain1: Mit Poti verbinden (Analoges Eingangssignal)
' - Pin PD6:      15K nach PB0/Ain2 (zum Laden/Entladen des Kondensators)
'-----------------------------------------------------------------------------------------------------------------------------
$Regfile="2313def.dat"  'AT90S2313-Deklarationen
$Crystal=3686400        'Verwendeter Quarz: 3.6864 MHz
$Baud   =1200           'Datenausgabe zum PC mit 1200 Baud
'
DDRD.6=1                'Pin PD6 als Ausgang konfigurieren (Ausgang=1, Eingang=0)
'Die Pins PB0/Ain2 und PB1/Ain1 mssen nicht explizit auf Eingang gesetzt werden, da dies der Initial-Zustand ist.
'
Config ACI=ON,Compare=OFF,Trigger=RISING  'Komparator im an steigender Flanke, keine Verbindung mit Timer1
Config Timer0=Timer,Prescale=8            'Timer-Betrieb, Clock/8: Nach (1/3,6864MHz)*8*256 = 555 Mikrosekunden berlauf
'
On ACI OnComparator     'Interrupt-Routine fr Komparator (Ende einer AD-Wandlung wegen normalem Ende der Messung)
On Timer0 OnOverflow    'Interrupt-Routine fr Timer0 (Ende einer AD-Wandlung wegen berlauf)
'
Dim Poti As Byte        'Die Variable Poti enthlt stets den aktuellen Annalog-(Poti-)-Wert
'-----------------------------------------------------------------------------------------------------------------------------
Enable Timer0           'Timer0-Overflow-Interrupt einschalten (initialisiert auch die erste Messung)
Enable Interrupts       'Interrupts global zulassen
Do                      'Hauptschleife
  PrintBin Poti         'UART-Datenausgabe
Loop
'-----------------------------------------------------------------------------------------------------------------------------
OnOverflow:             'Timer0-Overflow-Interrupt: Ende Entladen (oder zu hohe Spannung)
  Enable ACI
  PORTD.6=1             'Kondensator laden
  Timer0=0              'Timer0 zurcksetzen, Ende der Messung bei Komparator-Interrupt (oder Timer-berlauf)
Return
'-----------------------------------------------------------------------------------------------------------------------------
OnComparator:           'Komparator-Interrupt: AD/Wandlung beendet
  Poti=TIMER0-16        'Timer0-Wert holen und Interrupt-Zeit abziehen
  Disable ACI
  PORTD.6=0             'Kondensator entladen
  Timer0=128            'Timer0 so voreinstellen, da nach >200 Mikrosekunden Entladezeit berlauf
Return