'ADC02.BAS: A/D-Konverter mit dem Komparator und Timer1-Capture, Datenausgabe via UART
'Nutzbarer Bereich: 0,02V...4,75V (0...2100), bei den hheren Werten sehr nichtlinear
'Bentigte Hardware:
' - Nullmodemkabel zum PC fr die Datenausgabe
' - Pin PB0/Ain2: 1 nF nach Masse, 100K nach PD6 (Ladekondensator fr den Spannungsvergleich)
' - Pin PB1/Ain1: Mit Poti verbinden (Analoges Eingangssignal)
' - Pin PD6:      100K nach PB0/Ain2 (zum Laden/Entladen des Kondensators)
'Die RC-Kombination ist bewut extrem gehalten, um die Nichtlinearitt gut vorfhren zu knnen.
'-----------------------------------------------------------------------------------------------------------------------------
$Regfile="2313def.dat"  'AT90S2313-Deklarationen
$Crystal=3686400        'Verwendeter Quarz: 3.6864 MHz
$Baud   =1200           'Datenausgabe zum PC mit 1200 Baud
'
DDRD.6=1                'Pin PD6 als Ausgang konfigurieren (Ausgang=1, Eingang=0)
'Die Pins PB0/Ain2 und PB1/Ain1 mssen nicht explizit auf Eingang gesetzt werden, da dies der Initial-Zustand ist.
'
Config ACI=ON,Compare=ON,Trigger=RISING            'Komparator im an steigender Flanke, Ausgang mit Timer1 verbunden
Config Timer1=Timer,Capture Edge=RISING,Prescale=1 'Timer-Betrieb, CApture an steigender Flanke, Clock=Taktfrequenz
'
On Capture1 OnCapture   'Interrupt-Routine fr Capture-Ereignis (Ende einer AD-Wandlung wegen normalem Ende der Messung)
On Timer1 OnOverflow    'Interrupt-Routine fr Timer1 (Ende Entladen und Ende einer AD-Wandlung wegen berlauf)
'
Dim wPoti As Word       'Die Variable wPoti enthlt stets den aktuellen Annalog-(Poti-)-Wert
'-----------------------------------------------------------------------------------------------------------------------------
Enable Timer1           'Timer1-Overflow-Interrupt einschalten (initialisiert auch die erste Messung)
Enable Interrupts       'Interrupts global zulassen
Do                      'Hauptschleife
  Print wPoti;",";      'UART-Datenausgabe (hier als Text!)
Loop
'-----------------------------------------------------------------------------------------------------------------------------
OnOverflow:             'Timer1-Overflow-Interrupt: Ende Entladen (oder zu hohe Spannung)
  Enable Capture1       'Capture-Interrupt einschalten
  PORTD.6=1             'Kondensator laden
  Timer1=0              'Timer1 zurcksetzen, Ende der Messung bei Capture-Interrupt (oder Timer-berlauf)
Return
'-----------------------------------------------------------------------------------------------------------------------------
OnCapture:              'Capture-Interrupt: AD/Wandlung beendet
  wPoti=Capture1        'Timer1-Wert aus dem Capture-Register holen (enthlt Timer1-Wert zum Capture-Zeitpunkt)
  Disable Capture1      'Beim Entladen des Kondensators Capture-Interrupt ausschalten
  PORTD.6=0             'Kondensator entladen
  Timer1=60000          'Entladezeit bis Timer1-berlauf einstellen
Return