'ADC03.BAS: Vereinfachter A/D-Konverter mit Nutzung der internen PullUps
'Bentigte Hardware:
' - Nullmodemkabel zum PC fr die Datenausgabe
' - Pin PB0/Ain2: 3,9 nF nach Masse (0...244 ==> 0,58mV...4,9V)
' - Pin PB1/Ain1: Mit Poti verbinden (Analoges Eingangssignal)
'-----------------------------------------------------------------------------------------------------------------------------
$Regfile="2313def.dat"  'AT90S2313-Deklarationen
$Crystal=3686400        'Verwendeter Quarz: 3.6864 MHz
$Baud   =1200           'Datenausgabe zum PC mit 1200 Baud
'
Config ACI=ON,Compare=OFF,Trigger=RISING  'Komparator im an steigender Flanke, keine Verbindung mit Timer1
Config Timer0=Timer,Prescale=8            'Timer-Betrieb, Clock/8: Nach (1/3,6864MHz)*8*256 = 555 Mikrosekunden berlauf
'
On ACI OnComparator     'Interrupt-Routine fr Komparator (Ende einer AD-Wandlung wegen normalem Ende der Messung)
On Timer0 OnOverflow    'Interrupt-Routine fr Timer0 (Ende einer AD-Wandlung wegen berlauf)
'
Dim Poti As Byte        'Die Variable Poti enthlt stets den aktuellen Annalog-(Poti-)-Wert
'-----------------------------------------------------------------------------------------------------------------------------
Enable Timer0           'Timer0-Overflow-Interrupt einschalten (initialisiert auch die erste Messung)
Enable Interrupts       'Interrupts global zulassen
Do                      'Hauptschleife
  PrintBin Poti         'UART-Datenausgabe
Loop
'-----------------------------------------------------------------------------------------------------------------------------
OnOverflow:             'Timer0-Overflow-Interrupt: Ende Entladen (oder zu hohe Spannung)
  Enable ACI
  DDRB.0=0              'Laden starten: Pin PB0/Ain2 auf Eingang...
  PORTB.0=1             '...und PullUp einschalten
  Timer0=0              'Timer0 zurcksetzen, Ende der Messung bei Komparator-Interrupt (oder Timer-berlauf)
Return
'-----------------------------------------------------------------------------------------------------------------------------
OnComparator:           'Komparator-Interrupt: AD/Wandlung beendet
  Poti=TIMER0-16        'Timer0-Wert holen und Interrupt-Zeit abziehen
  Disable ACI
  PORTB.0=0             'Entladen: Pin PB0/Ain2 auf 0 Volt...
  DDRB.0=1              '...und auf Ausgang
  Timer0=254            'Entlade-Ende bei berlauf (hier nur relativ wenige Takte ntig, da Entladen nicht ber Widerstand)
Return