'DAC01.BAS: Einfacher D/A-Wandler, Helligkeitssteuerung bei einer LED
'           Der Helligkeitswert wird per Terminalprogramm an den AVR geschickt
'Bentigte Hardware:
' - Nullmodemkabel zum PC fr die Dateneingabe (Helligkeitssteuerung)
' - Pin PD5: Mit LED verbinden
'-----------------------------------------------------------------------------------------------------------------------------
$Regfile="2313def.dat"   'AT90S2313-Deklarationen
$Crystal=3686400         'Verwendeter Quarz: 3.6864 MHz
$Baud   =9600            '9600 Baud
'
On Timer0 OnTimer        'Timer0-Interrupt-Overflow-Handler festlegen
Config Timer0=TIMER,Prescale=256 'Mgliche Vorteilungen: 1/8/64/256/1024
'Bei Vorteilung 1024 flimmert die LED und bei Vorteilung 1 wird unverhltnismig viel
'Rechenzeit fr die Ansteuerung der LED verbraucht. Die Vorteilung 256 ist bei 3,6864MHz
'wirklich optimal. Die "Flimmerfrequenz" der LED ist dann 3686400Hz/256/256=56,25Hz.
'
Dim Helligkeit As Byte   'Variabler Zeitwert fr Timer0 (Helligkeit der LED)
'
DDRD.5=1                 'Pin PD5 ist Ausgang
Helligkeit=255           'Initiale Helligkeit der LED: Maximum
Enable Timer0            'Timer0-Overflow-Interrupt einschalten
Enable Interrupts        'Interrupts global einschalten
'-----------------------------------------------------------------------------------------------------------------------------
Do                       'Hauptschleife
  If USR.RXC=1 Then      'Falls ein Zeichen im UART-Puffer ist (UartStartusRegister.ReceiveComplete=1)...
    Helligkeit=UDR       '...dann neuen Wert fr die Helligkeit aus dem UartDataRegister holen.
  End If
Loop
'-----------------------------------------------------------------------------------------------------------------------------
OnTimer:
  PORTD.5=Not PORTD.5    'LED-Status wechseln (LED an oder ausschalten)
  If PORTD.5=1 Then      'Wenn die LED gerade an ist
   Timer0=256-Helligkeit 'Anwender-Zeitwert setzen (-..., weil Timer0 vorwrts zhlt, bis er berluft)
  Else                   'Wenn die LED gerade aus ist
   Timer0=Helligkeit     'Komplementre Zeit der High-Periode (H und L zusammen immer 256 Timer1-Takte)
  End If
Return