'DAC04.BAS: LED-Helligkeit mit PWM-Ausgabe von Timer1 regeln
'Hardware:  Pin OC1/PB3 mit LED verbinden
'           Nullmodemkabel vom AVR-Board zum PC, Steuerung ber AvrTerm
'Funktion:  LED-Helligkeit ber gesendete ASCII-Zeichen regeln.
'           Bei ASCII-0 ist die LED aus, bei ASCII-255 am hellsten.
'------------------------------------------------------------------------------
$Regfile="2313def.dat"   'AT90S2313-Deklarationen
$Crystal=3686400         'Verwendeter Quarz: 3.6864 MHz
$Baud   =9600            '9600 Baud
'
DDRB.3=1                 'Pin PB3/OC1 auf Ausgang setzen (1=Ausgang, 0=Eingang)
'
'Timer1 konfigurieren:
'Die Konfiguration von Timer1 direkt ber die Timer1-Register ist zum Verstndnis
'der PWM-Ausgabe besser als "Config Timer1". Wir wollen Timer1 im PWM-Modus mit
'8 Bit Breite betreiben (0...255). Den ntigen Vergleichswert fr Timer1 bergeben
'wir dann ber die serielle Schnittstelle.
'Sobald Timer1 beim Hochzhlen den Vergleichswert erreicht hat, soll der Timer1-
'Ausgangs-Pin PB3/OC1 auf Low gehen. Timer1 zhlt dann weiter, bis 255 erreicht
'ist und zhlt dann rckwrts, bis widerum der Vergleichswert erreicht ist. In
'diesem Moment wird der Timer1-Ausgangs-Pin PB3/OC1 auf High gesetzt. Timer1 zhlt
'dann weiter rckwrts bis zur 0 und dann wieder aufwrts (u.s.w.).
'Im Ergebnis haben wir an Pin PB3/OC1 ein Rechtecksignal konstanter Frequenz, aber
'wir knnen die Pulsweite ber den Timer1-Vergleichswert verndern. Nach Glttung
'mit einem RC-Glied knnen wir so eine vernderliche Gleichspannung erzeugen.
'Bei der Demonstration mit einer LED brauchen wir aber kein RC-Glied, da hier die
'Trgheit der Augen die "Glttung" vornimmt.
'
'Timer1 konfigurieren:
TCCR1A=&B10000001   'Bits7+6=10: Pin OC1 Low wenn Vergleichswert erreicht; Bit1+0=01: 8-Bit-PWM
TCCR1B=&B00000010   'Bits2+1+0=010: Timer1-Vorteilung 1/8 (ergibt bei 8-Bit PWM die Frequenz 3686400Hz/8/510=903,53Hz)
'
'Jetzt mu noch der Vergleichswert fr Timer1 gesetzt werden. Wenn der Timer1-PWM
'im 8-Bit-Modus luft, braucht der Vergleichswert nur ins LowByte-Register OCR1AL
'kopiert zu werden, weil dann das HighByte-Register OCR1AH ignoriert wird.
'Wenn Timer1 aber im 9- oder 10-Bit-PWM-Modus luft, dann mu der 16-bit-Ver-
'gleichswert getrennt in HighByte und LowByte in die Register OCR1H und OCR1L
'geschrieben werden, und zwar stets das HighByte zuerst. Wer das nicht zu Fu
'machen will, kann den 16-Bit-Vergleichswert auch mit einer Befehlszeile ins
'Bascom-Pseudoregister COMPARE1A kopieren und Bascom erledigt die Aufteilung in
'High- und LowByte im Hintergrund.
OCR1AL=127       'Nur bei 8-Bit-PWM mglich (bei 9- oder 10-Bit Pseudoregister COMPARE1A nehmen)
'------------------------------------------------------------------------------
Do                       'Hauptschleife
  If USR.RXC=1 Then      'Falls ein Zeichen im UART-Puffer ist (UartStartusRegister.ReceiveComplete=1)...
    OCR1AL=UDR           '...dann neuen Wert fr die Helligkeit aus dem UartDataRegister holen.
  End If
Loop
'------------------------------------------------------------------------------