'PIM_RX.BAS: 1-Kanal-PIM-Empfnger (PIM: Puls-Intervall-Modulation), passend zum Programm PIM_TX.BAS
'Hardware:   Draht vom sendenden AVR zum Eingangspin ICP/PD6 (InputCapturePin von Timer1)
'            oder alternativ zum Komparator-Eingangspin Ain1/PB1. Wird der Komparator-Eingang benutzt, dann zustzlich
'            den zweiten Komparatoreingang Ain2/PB1 mit Poti2 verbinden und Poti-Schleifer auf Mittelstellung.
'            Nullmodemkabel zum PC, um die empfangenen Zeichen in einem Terminalprogramm anzeigen zu knnen
'Funktion:   Empfngt Text mit Pulsintervallmodulation und schickt ihn zur Darstellung ans Terminalprogramm AvrTerm.
'            Bei PIM wird der zu sendende Wert im Zeitabstand zwischen zwei gesendeten Pulsen codiert.
'            Die Datenbertragung erfolgt hier per Leitung, eigentlicher Einsatz ist aber Infrarot, Laser oder Funk.
'-----------------------------------------------------------------------------------------------------------------------------
$Regfile="2313def.dat"     'AT90S2313-Deklarationen
$Crystal=3686400           'Verwendeter Quarz: 3.6864 MHz
$Baud   =19200             'RS232-Baudrate 19200 Baud
'
Dim wTemp As Word          'Temporr-Variable
Dim wCurCount As Word      'Nimmt den aktuellen Zhlerstand von Timer1 auf
Dim CurChar As Byte        'Nimmt das gerade empfangene ASCII-Zeichen auf
'
On ICP1 OnCapture          'Bei Capture-Ereignis nach OnCapture springen

'Timer1 konfigurieren:
TCCR1B=&B11000001          'Bit7=1: Input-NoiseCanceler ein, Bit6=1: Capture an steigender Flanke, Bits2-0=001: keine Timer1-Vorteilung
'
'Bitte Kommentarstriche von der nchsten Zeile entfernen, wenn der Komparator als Capture-Eingang dienen soll.
'Achtung: Dann Pin Ain1/PB1 als Signaleingang nehmen und Pin Ain2/PB0 mit Poti verbinden (Schleifer erst mal auf Mittelstellung).
'ACSR=&B00000111  'Bit7=0: Komparator ein, Bit2=1: Komparator-Ausgang mit Timer1-Capture-Eingang verbinden, Bits10=11: Steigende Flanke
'
Enable Capture1            'Timer1-Capture-Interrupt einschalten
Enable Interrupts          'Ab jetzt Interrupts zulassen
'-----------------------------------------------------------------------------------------------------------------------------
Main:                      'Hauptschleife
GOTO Main
'-----------------------------------------------------------------------------------------------------------------------------
OnCapture:                 'Ein PIM-Puls ist eingetroffen
  'Als allererste Aktion holen wir den Zhlerstand seit dem letzten Puls und laden Timer1 neu fr den nchsten Puls
  wTemp=TIMER1             'Zuerst den tatschlichen momentanen Timer1-Wert holen
  wCurCount=CAPTURE1       'Tatschlichen Capture-Wert zum Interrupt-Zeitpunkt holen (CAPTURE1<TIMER1)
  wTemp=wTemp-wCurCount    'Differenz ziwschen Interrupt- und tatschlicher Timer1-Zeit (Interrupt-Verzgerungen sind mglich!)
  TIMER1=wTemp+64          'Timer1 mit der Zeit-Differenz plus Korrekturwert fr den verwendeten Code neu laden
  '
  'Jetzt den Timer1-Capture-Zhlerstand in das gesendete ASCII-Zeichen zurckrechnen
  wCurCount=wCurCount-1023 'Konstanten Zeitoffset abziehen (mehr siehe PIM_TX.BAS)
  Shift wCurCount,Right,4  'Bit-Shift des PIM-Senders rckgngig machen (mehr siehe PIM_TX.BAS)
  CurChar=wCurCount        'Jetzt haben wir das Zeichen...
  UDR=CurChar              '...und schicken es zur Kontrolle per UART zum PC
Return
'-----------------------------------------------------------------------------------------------------------------------------