'PIM_TX.BAS: 1-Kanal-PIM-Sender (PIM: Pulsintervallmodulation, Codierung in den zeitabstnden zwischen zwei Pulsen)
'Hardware:   Pin OC1/PB3 und Masse mit Datenempfnger verbinden
'Funktion:   Sendet normalen Text (ASCII-Zeichen 0...255) per PIM.
'----------------------------------------------------------
$Regfile="2313def.dat"  'AT90S2313-Deklarationen
$Crystal=3686400        'Verwendeter Quarz: 3.6864 MHz
'
Dim szText As String*20 At &H60      'Zu sendender Text (&H60: Erstes Byte im SRAM)
Dim Text(20) As Byte At &H60 Overlay 'Vereinfacht Zugriff auf die Text-Bytes
Dim CurTextPos As Byte               'Die aktuelle Position im zu sendenden Text
Dim wTemp As Word                    'Fr temporre Zwecke
'
szText="Hallo Welt,"    'Der zu sendende Text
CurTextPos=1            'Textposition initial auf erstes Zeichen setzen
DDRB.3=1                'Pin PB3/OC1 ist Ausgang (1=Ausgang, 0=Eingang)
'
'Timer1 konfigurieren:
TCCR1A=&B11000000       'Bits 7+6=11: Bei Compare-Ereignis Pin OC1/PB3 auf High
TCCR1B=&B00001001       'Bit3=1: Bei Compare-Ereignis Timer1-Reset; Bits0-2=001: keine Vorteilung
'
On COMPARE1 OnPimPulse  'Interrupt-Routine fr Timer1-Compare
'----------------------------------------------------------
Enable COMPARE1A        'Timer1-Compare-Interrupt ein
Enable Interrupts       'Interrupts global einschalten
Do                      'Hauptschleife
Loop
'----------------------------------------------------------
OnPimPulse:            'Vergleichswert erreicht, PIM-Puls wutrde gesendet
  'Pin OC1/PB3 zurcksetzen, das geht beim AT90S2313 leider nur ber ein Zwischen-Compare-Ereignis:
  TCCR1B=&B00000001      'Bit3=0: Bei Compare-Ereignis KEIN Timer1-Reset (mu weiterzhlen!), Bits3+2+1+0=001: keine Vorteilung
  TCCR1A=&B10000000      'Bits 7+6=10: Beim nchsten Compare-Ereignis soll Pin OC1/PB3 auf Low gehen
  COMPARE1A=TIMER1+14    'Zeitpunkt fr das "Zwischen"-Compare-Ereignis setzen (beim hier verwendeten Code EXAKT +14)
  TCCR1A=&B11000000      'Bits 7+6=11: Bei nchstem Compare-Ereignis Pin OC1/PB3 wieder auf High setzen
  TCCR1B=&B00001001      'Bit3=1: Bei Compare-Ereignis Timer1-Reset; Bits0-2=001: Keine Vorteilung
  TIFR.OCF1A=1           'Compare-Interruptanforderung lschen; wurde von uns beim Umkonfigurieren erzeugt (ja, 1 schreiben!)
  '
  'Nchsten "normalen" Compare-Zhlerstand setzen:
  wTemp=Text(CurTextPos) 'Aktuelles Textzeichen holen
  Shift wTemp,Left,4     'Mindestens ein Shift wegen Digitalisierungsfehler im Empfnger, weitere Shifts zur Erhung der Schrittweite bei den Pulsabstnden
  wTemp=wTemp+1023       'Konstanter Zeitoffset: 1. Zeit zur Verarbeitung kurzer Pulslngen, 2. Bereich festlegen ("hchste Frequenz")
                         'Mit den gewhlten Einstellungen bei Timer1-Vorteilung, Shift und Offset ergeben sich folgende Pulsabstnde:
                         'ASCII-0   hat 3686400Hz/1024           =3600Hz      =0,2777 Millisekunden.
                         'ASCII-255 hat 3686400Hz/(1024+(255*16))=722,257...Hz=1,3845... Millisekunden.
                         'Als Pulslngenunterschied zwischen zwei Zeichen ergibt sich 11,241...Hz=88,958... Millisekunden
                         'Beim normalen ASCII-Text ergben sich im Durchschnitt also rund 1300 Baud, bei nach Zeichenhufifgkeit
                         'optimiertem Alphabet (wie beim Morsecode oder PSK31) htte man im Durchschnitt vielleicht 2700 Baud
                         'und bei rein zuflligen ASCII-Zeichen (z.B. ZIP-Datei) ziemlich genau 1200 Baud.
                         'Der Vorteil gegenber PacketRadio wre also eher die viel einfachere und billigere Technik und die
                         'Mglichkeit, zustzlich zu den 255 ASCII-Zeichen spezielle Pulslngen fr Betriebszwecke zu definieren,
                         'z.B. Paketstart und -Ende oder hnliches. Das erspart das umstndliche Umcodieren des eigentlichen Inhalts.
                         'Warnung: Ich habe noch keine Praxistests mit FM-Handfunkgerten gemacht, sondern nur mit ISM-Spezial-ICs
                         'und anderen Spezial-Sendern und Empfngern.
  COMPARE1A=wTemp        'Ergebnis ins Timer1-Compare-Register
  '
  Incr CurTextPos        'Nchstes zu sendendes Zeichen einstellen
  If CurTextPos>Len(szText) Then CurTextPos=1
Return